# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xsqlalias`](#dsc_xsqlalias): The DSC xSqlAlias resource type. Automatically generated from version 1.4.0.0
* [`dsc_xsqlhaendpoint`](#dsc_xsqlhaendpoint): The DSC xSqlHAEndPoint resource type. Automatically generated from version 1.4.0.0
* [`dsc_xsqlhagroup`](#dsc_xsqlhagroup): The DSC xSqlHAGroup resource type. Automatically generated from version 1.4.0.0
* [`dsc_xsqlhaservice`](#dsc_xsqlhaservice): The DSC xSqlHAService resource type. Automatically generated from version 1.4.0.0
* [`dsc_xsqlserverinstall`](#dsc_xsqlserverinstall): The DSC xSqlServerInstall resource type. Automatically generated from version 1.4.0.0
* [`dsc_xwaitforsqlhagroup`](#dsc_xwaitforsqlhagroup): The DSC xWaitForSqlHAGroup resource type. Automatically generated from version 1.4.0.0

## Resource types

### `dsc_xsqlalias`

The DSC xSqlAlias resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xsqlalias` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

 

##### `dsc_pipename`

Data type: `Optional[String]`

 

##### `dsc_protocol`

Data type: `Optional[Enum['TCP', 'NP']]`

 

##### `dsc_servername`

Data type: `Optional[String]`

 

##### `dsc_tcpport`

Data type: `Optional[Integer[-2147483648, 2147483647]]`

 

#### Parameters

The following parameters are available in the `dsc_xsqlalias` type.

##### `dsc_name`

namevar

Data type: `String`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xsqlhaendpoint`

The DSC xSqlHAEndPoint resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xsqlhaendpoint` type.

##### `dsc_alloweduser`

Data type: `String`

Windows Account that could access the HA database mirroring endpoing.

##### `dsc_portnumber`

Data type: `Optional[Integer[0, 4294967295]]`

The single port number(nnnn) on which the Sql HA to listen to.

#### Parameters

The following parameters are available in the `dsc_xsqlhaendpoint` type.

##### `dsc_instancename`

namevar

Data type: `String`

Name of Sql Instance.

##### `dsc_name`

namevar

Data type: `String`

Unique name for HA database mirroring endpoint of the sql instance.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xsqlhagroup`

The DSC xSqlHAGroup resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xsqlhagroup` type.

##### `dsc_clustername`

Data type: `String`

The name of windows failover cluster for the availability group

##### `dsc_database`

Data type: `Array[String]`

Array of databases on the local sql instance. Each database can belong to only one HA group.

##### `dsc_databasebackuppath`

Data type: `String`

The net share for Sql replication initialization

##### `dsc_endpointname`

Data type: `String`

Name of EndPoint to access High Availability sql instance.

##### `dsc_instancename`

Data type: `String`

Name of sql instance

#### Parameters

The following parameters are available in the `dsc_xsqlhagroup` type.

##### `dsc_domaincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Domain credential could get list of cluster nodes.

##### `dsc_name`

namevar

Data type: `String`

The name of sql availability group

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_sqladministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Sql sa credential.

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xsqlhaservice`

The DSC xSqlHAService resource type.
Automatically generated from version 1.4.0.0

#### Parameters

The following parameters are available in the `dsc_xsqlhaservice` type.

##### `dsc_instancename`

namevar

Data type: `String`

The name of Sql instance.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_servicecredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Domain credential to run sql service

##### `dsc_sqladministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Sql sa credential

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xsqlserverinstall`

The DSC xSqlServerInstall resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xsqlserverinstall` type.

##### `dsc_agentsvcaccount`

Data type: `Optional[String]`

Specify the account for SQL server agent service.

##### `dsc_features`

Data type: `Optional[String]`

List of names of Sql Server features to install

##### `dsc_installsqldatadir`

Data type: `Optional[String]`

Specify the directory for SQL server system db files

##### `dsc_sourcepath`

Data type: `String`

The share path of sql server software.

##### `dsc_sqlbackupdir`

Data type: `Optional[String]`

Specify the directory for backup files.

##### `dsc_sqlcollation`

Data type: `Optional[String]`

Specify the default collation for SQL server

##### `dsc_sqltempdbdir`

Data type: `Optional[String]`

Specify the directory for TempDB files.

##### `dsc_sqluserdbdir`

Data type: `Optional[String]`

Specify the directory for UserDB data files.

##### `dsc_sqluserdblogdir`

Data type: `Optional[String]`

Specify the directory for UserDB log files.

##### `dsc_svcaccount`

Data type: `Optional[String]`

Specify the startup account for the SQL server service.

##### `dsc_sysadminaccounts`

Data type: `Optional[String]`

Specify logins to be members of the sysadmin role.

##### `dsc_updateenabled`

Data type: `Optional[Boolean]`

Specify whether SQL server setup should discover and include product updates.

##### `dsc_versionid`

Data type: `Optional[String]`

The numeric version identifier for the instance to be installed

#### Parameters

The following parameters are available in the `dsc_xsqlserverinstall` type.

##### `dsc_instancename`

namevar

Data type: `String`

The name of sql instance.

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_sourcepathcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The credential that vm could use to access net share of sql server software.

##### `dsc_sqladministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Sql sa credential

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

### `dsc_xwaitforsqlhagroup`

The DSC xWaitForSqlHAGroup resource type.
Automatically generated from version 1.4.0.0

#### Properties

The following properties are available in the `dsc_xwaitforsqlhagroup` type.

##### `dsc_clustername`

Data type: `String`

The name of windows failover cluster for the availability group.

##### `dsc_instancename`

Data type: `String`

The name of sql instance.

##### `dsc_retrycount`

Data type: `Optional[Integer[0, 4294967295]]`

Maximum number of retries to check HA group existency

##### `dsc_retryintervalsec`

Data type: `Optional[Integer[0, 18446744073709551615]]`

Interval to check the HA group existency

#### Parameters

The following parameters are available in the `dsc_xwaitforsqlhagroup` type.

##### `dsc_domaincredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Domain credential could get list of cluster nodes.

##### `dsc_name`

namevar

Data type: `String`

The name of Sql High Availability group

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### `dsc_sqladministratorcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Sql sa credential

##### `name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

