require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_xsqlhaendpoint',
  dscmeta_resource_friendly_name: 'xSqlHAEndPoint',
  dscmeta_resource_name: 'MSFT_xSqlHAEndPoint',
  dscmeta_module_name: 'xSqlPs',
  dscmeta_module_version: '1.4.0.0',
  docs: 'The DSC xSqlHAEndPoint resource type.
         Automatically generated from version 1.4.0.0',
  features: ['simple_get_filter', 'canonicalize'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    dsc_instancename: {
      type: 'String',
      desc: 'Name of Sql Instance.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_portnumber: {
      type: 'Optional[Integer[0, 4294967295]]',
      desc: 'The single port number(nnnn) on which the Sql HA to listen to.',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'UInt32',
      mof_is_embedded: false,
    },
    dsc_name: {
      type: 'String',
      desc: 'Unique name for HA database mirroring endpoint of the sql instance.',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_alloweduser: {
      type: 'String',
      desc: 'Windows Account that could access the HA database mirroring endpoing.',

      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
